3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
105 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
106 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
107 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
109 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
116 # Prior to calling, cmd_update checks that a possibly existing
117 # path is not a git repository.
118 # Likewise, cmd_add checks that path does not exist at all,
119 # since it is the location of a new submodule.
127 if test -n "$GIT_QUIET"
134 name=$(module_name "$sm_path" 2>/dev/null)
135 test -n "$name" || name="$sm_path"
136 base_name=$(dirname "$name")
138 gitdir=$(git rev-parse --git-dir)
139 gitdir_base="$gitdir/modules/$base_name"
140 gitdir="$gitdir/modules/$name"
145 rm -f "$gitdir/index"
147 mkdir -p "$gitdir_base"
148 git clone $quiet -n ${reference:+"$reference"} \
149 --separate-git-dir "$gitdir" "$url" "$sm_path" ||
150 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
153 a=$(cd "$gitdir" && pwd)/
154 b=$(cd "$sm_path" && pwd)/
155 # normalize Windows-style absolute paths to POSIX-style absolute paths
156 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
157 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
158 # Remove all common leading directories after a sanity check
159 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
160 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
162 while test "${a%%/*}" = "${b%%/*}"
167 # Now chop off the trailing '/'s that were added in the beginning
171 # Turn each leading "*/" component into "../"
172 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
173 echo "gitdir: $rel/$a" >"$sm_path/.git"
175 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
176 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
180 # Add a new submodule to the working tree, .gitmodules and the index
184 # optional branch is stored in global branch variable
188 # parse $args after "submodule ... add".
193 case "$2" in '') usage ;; esac
204 case "$2" in '') usage ;; esac
205 reference="--reference=$2"
229 if test -z "$sm_path"; then
230 sm_path=$(echo "$repo" |
231 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
234 if test -z "$repo" -o -z "$sm_path"; then
238 # assure repo is absolute or relative to parent
241 # dereference source url relative to parent's url
242 realrepo=$(resolve_relative_url "$repo") || exit
249 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
254 # multiple //; leading ./; /./; /../; trailing /
255 sm_path=$(printf '%s/\n' "$sm_path" |
265 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
266 die "$(eval_gettext "'\$sm_path' already exists in the index")"
268 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
270 eval_gettextln "The following path is ignored by one of your .gitignore files:
272 Use -f if you really want to add it." >&2
276 # perhaps the path exists and is already a git repo, else clone it
277 if test -e "$sm_path"
279 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
281 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
283 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
288 module_clone "$sm_path" "$realrepo" "$reference" || exit
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
294 '') git checkout -f -q ;;
295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
299 git config submodule."$sm_path".url "$realrepo"
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
304 git config -f .gitmodules submodule."$sm_path".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_path".url "$repo" &&
306 git add --force .gitmodules ||
307 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
311 # Execute an arbitrary command sequence in each checked out
314 # $@ = command to execute
318 # parse $args after "submodule ... foreach".
340 # dup stdin so that it can be restored when running the external
341 # command in the subshell (and a recursive call to this function)
345 while read mode sha1 stage sm_path
347 if test -e "$sm_path"/.git
349 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
350 name=$(module_name "$sm_path")
352 prefix="$prefix$sm_path/"
354 # we make $path available to scripts ...
358 if test -n "$recursive"
360 cmd_foreach "--recursive" "$@"
363 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
369 # Register submodules in .git/config
371 # $@ = requested paths (default to all)
375 # parse $args after "submodule ... init".
397 while read mode sha1 stage sm_path
399 name=$(module_name "$sm_path") || exit
401 # Copy url setting when it is not set yet
402 if test -z "$(git config "submodule.$name.url")"
404 url=$(git config -f .gitmodules submodule."$name".url)
406 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
408 # Possibly a url relative to parent
411 url=$(resolve_relative_url "$url") || exit
414 git config submodule."$name".url "$url" ||
415 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
417 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
420 # Copy "update" setting when it is not set yet
421 upd="$(git config -f .gitmodules submodule."$name".update)"
423 test -n "$(git config submodule."$name".update)" ||
424 git config submodule."$name".update "$upd" ||
425 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
430 # Update each submodule path to correct revision, using clone and checkout as needed
432 # $@ = requested paths (default to all)
436 # parse $args after "submodule ... update".
457 case "$2" in '') usage ;; esac
458 reference="--reference=$2"
459 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
485 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
491 cmd_init "--" "$@" || return
497 while read mode sha1 stage sm_path
501 echo >&2 "Skipping unmerged submodule $sm_path"
504 name=$(module_name "$sm_path") || exit
505 url=$(git config submodule."$name".url)
506 if ! test -z "$update"
508 update_module=$update
510 update_module=$(git config submodule."$name".update)
513 if test "$update_module" = "none"
515 echo "Skipping submodule '$sm_path'"
521 # Only mention uninitialized submodules when its
522 # path have been specified
524 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
525 Maybe you want to use 'update --init'?")"
529 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
531 module_clone "$sm_path" "$url" "$reference"|| exit
532 cloned_modules="$cloned_modules;$name"
535 subsha1=$(clear_local_git_env; cd "$sm_path" &&
536 git rev-parse --verify HEAD) ||
537 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
540 if test "$subsha1" != "$sha1"
543 # If we don't already have a -f flag and the submodule has never been checked out
544 if test -z "$subsha1" -a -z "$force"
549 if test -z "$nofetch"
551 # Run fetch only if $sha1 isn't present or it
552 # is not reachable from a ref.
553 (clear_local_git_env; cd "$sm_path" &&
554 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
555 test -z "$rev") || git-fetch)) ||
556 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
559 # Is this something we just cloned?
560 case ";$cloned_modules;" in
562 # then there is no local change to integrate
567 case "$update_module" in
570 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
571 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
572 must_die_on_failure=yes
576 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
577 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
578 must_die_on_failure=yes
581 command="git checkout $subforce -q"
582 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
583 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
587 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
590 elif test -n "$must_die_on_failure"
592 die_with_status 2 "$die_msg"
594 err="${err};$die_msg"
599 if test -n "$recursive"
601 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
605 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
608 err="${err};$die_msg"
611 die_with_status $res "$die_msg"
638 git describe "$2" 2>/dev/null ||
639 git describe --tags "$2" 2>/dev/null ||
640 git describe --contains "$2" 2>/dev/null ||
641 git describe --all --always "$2"
644 test -z "$revname" || revname=" ($revname)"
647 # Show commit summary for submodules in index or working tree
649 # If '--cached' is given, show summary between index and given commit,
650 # or between working tree and given commit
652 # $@ = [commit (default 'HEAD'),] requested paths (default all)
659 # parse $args after "submodule ... summary".
673 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
695 test $summary_limit = 0 && return
697 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
701 elif test -z "$1" -o "$1" = "HEAD"
703 # before the first commit: compare with an empty tree
704 head=$(git hash-object -w -t tree --stdin </dev/null)
705 test -z "$1" || shift
713 die "$(gettext -- "--cached cannot be used with --files")"
719 # Get modified modules cared by user
720 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
721 sane_egrep '^:([0-7]* )?160000' |
722 while read mod_src mod_dst sha1_src sha1_dst status name
724 # Always show modules deleted or type-changed (blob<->module)
725 test $status = D -o $status = T && echo "$name" && continue
726 # Also show added or modified modules which are checked out
727 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
732 test -z "$modules" && return
734 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
735 sane_egrep '^:([0-7]* )?160000' |
737 while read mod_src mod_dst sha1_src sha1_dst status name
739 if test -z "$cached" &&
740 test $sha1_dst = 0000000000000000000000000000000000000000
744 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
746 100644 | 100755 | 120000)
747 sha1_dst=$(git hash-object $name)
753 eval_gettextln "unexpected mode \$mod_dst" >&2
760 test $mod_src = 160000 &&
761 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
764 test $mod_dst = 160000 &&
765 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
769 case "$missing_src,$missing_dst" in
771 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
774 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
777 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
782 if test $mod_src = 160000 -a $mod_dst = 160000
784 range="$sha1_src...$sha1_dst"
785 elif test $mod_src = 160000
791 GIT_DIR="$name/.git" \
792 git rev-list --first-parent $range -- | wc -l
794 total_commits=" ($(($total_commits + 0)))"
798 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
799 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
802 blob="$(gettext "blob")"
803 submodule="$(gettext "submodule")"
804 if test $mod_dst = 160000
806 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
808 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
811 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
815 # Don't give error msg for modification whose dst is not submodule
816 # i.e. deleted or changed to blob
817 test $mod_dst = 160000 && echo "$errmsg"
819 if test $mod_src = 160000 -a $mod_dst = 160000
822 test $summary_limit -gt 0 && limit="-$summary_limit"
823 GIT_DIR="$name/.git" \
824 git log $limit --pretty='format: %m %s' \
825 --first-parent $sha1_src...$sha1_dst
826 elif test $mod_dst = 160000
828 GIT_DIR="$name/.git" \
829 git log --pretty='format: > %s' -1 $sha1_dst
831 GIT_DIR="$name/.git" \
832 git log --pretty='format: < %s' -1 $sha1_src
838 if test -n "$for_status"; then
839 if [ -n "$files" ]; then
840 gettextln "# Submodules changed but not updated:"
842 gettextln "# Submodule changes to be committed:"
845 sed -e 's|^|# |' -e 's|^# $|#|'
851 # List all submodules, prefixed with:
852 # - submodule not initialized
853 # + different revision checked out
855 # If --cached was specified the revision in the index will be printed
856 # instead of the currently checked out revision.
858 # $@ = requested paths (default to all)
862 # parse $args after "submodule ... status".
887 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
892 while read mode sha1 stage sm_path
894 name=$(module_name "$sm_path") || exit
895 url=$(git config submodule."$name".url)
896 displaypath="$prefix$sm_path"
899 say "U$sha1 $displaypath"
902 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
904 say "-$sha1 $displaypath"
907 set_name_rev "$sm_path" "$sha1"
908 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
910 say " $sha1 $displaypath$revname"
914 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
915 set_name_rev "$sm_path" "$sha1"
917 say "+$sha1 $displaypath$revname"
920 if test -n "$recursive"
923 prefix="$displaypath/"
926 eval cmd_status "$orig_args"
928 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
933 # Sync remote urls for submodules
934 # This makes the value for remote.$remote.url match the value
935 # specified in .gitmodules.
960 while read mode sha1 stage sm_path
962 name=$(module_name "$sm_path")
963 url=$(git config -f .gitmodules --get submodule."$name".url)
965 # Possibly a url relative to parent
968 url=$(resolve_relative_url "$url") || exit
972 if git config "submodule.$name.url" >/dev/null 2>/dev/null
974 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
975 git config submodule."$name".url "$url"
977 if test -e "$sm_path"/.git
982 remote=$(get_default_remote)
983 git config remote."$remote".url "$url"
990 # This loop parses the command line arguments to find the
991 # subcommand name to dispatch. Parsing of the subcommand specific
992 # options are primarily done by the subcommand implementations.
993 # Subcommand specific options such as --branch and --cached are
994 # parsed here as well, for backward compatibility.
996 while test $# != 0 && test -z "$command"
999 add | foreach | init | update | status | summary | sync)
1029 # No command word defaults to "status"
1030 test -n "$command" || command=status
1032 # "-b branch" is accepted only by "add"
1033 if test -n "$branch" && test "$command" != add
1038 # "--cached" is accepted only by "status" and "summary"
1039 if test -n "$cached" && test "$command" != status -a "$command" != summary